#!============================================================================
#! Matplotlib
#!============================================================================
from matplotlib import  pyplot as plt
import pylab
import numpy
import random

#! 1 Plot a sine function in red with a dashed linestyle
x = numpy.arange(0,10.,0.01)
y = numpy.sin(x)
pylab.plot(x,y,'r--',label="sin(x)")


#! 2 Add title, labels, legend etc. in fontsize 20 and in green
params = {'fontsize':20,'color':'green'}
pylab.title('Title',**params)
pylab.xlabel('X',**params)
pylab.ylabel('Y',**params)
pylab.legend()



fontsizes = [8, 16, 24, 32]
fig, (ax1, ax2) = plt.subplots(nrows=2, ncols=1)
x=numpy.arange(0,2*numpy.pi,0.01)
p1,=ax1.plot(x,numpy.sin(x),'r')
p2,=ax1.plot(x,numpy.cos(x),'b')
ax1.set_xlabel('x-label', fontsize=random.choice(fontsizes))
ax1.set_ylabel('y-label', fontsize=random.choice(fontsizes))
ax1.set_title('Title', fontsize=random.choice(fontsizes))
ax1.legend([p1,p2],["sin","cos"])
ax2.plot(x,numpy.cos(x)*numpy.sin(x))
ax2.set_xlabel('x-label', fontsize=random.choice(fontsizes))
ax2.set_ylabel('y-label', fontsize=random.choice(fontsizes))
ax2.set_title('Title', fontsize=random.choice(fontsizes))
pylab.tight_layout()



#! 3 Create a sequence of 10 images in which the sine function slowly evolves over time.
#Update the data in the figure, do NOT create a new figure for each time value
pylab.figure()
x = numpy.arange(0,10.,0.1)
y = numpy.sin(x)
time_steps = numpy.linspace(0,10,10)

xs = x[x<time_steps[0]]
ys = y[x<time_steps[0]]
l,=plt.plot(xs,ys,'k')
m,=plt.plot(xs,ys,'or')
pylab.yticks([])
pylab.xlim(0,10)
pylab.ylim(-1,1)
pylab.show()
for i in range(1,10,1):
    xs = x[x<time_steps[i]]
    ys = y[x<time_steps[i]]
    l.set_data(xs,ys)
    m.set_data(xs[-1],ys[-1]) #draw last point 
    pylab.draw()
    pylab.pause(0.1)
pylab.show()





